BledDest's blog

By BledDest, history, 7 years ago, translation, In English
Tutorial is loading...
Tutorial is loading...
Tutorial is loading...
Tutorial is loading...
Tutorial is loading...
Tutorial is loading...
Tutorial is loading...
  • Vote: I like it
  • +68
  • Vote: I do not like it

| Write comment?
»
7 years ago, # |
  Vote: I like it 0 Vote: I do not like it

In problem F The length of the smallest period is (|t|-plast) instead of |t|/(|t|-plast).

»
7 years ago, # |
Rev. 2   Vote: I like it +6 Vote: I do not like it

in problem E , why does this logic fails ?
1 : pick vertex with zero in-degree (and with minimum node number ,in case of tie in degree)
2 : remove this vertex from the graph and update degree of all other nodes attached to this.
3 : assign label to this removed vertex
4 : repeat above steps while there are nodes in graph

labels are assigned from 1 to N

  • »
    »
    7 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    Becouse then you firstly attach one to first vertex it might have parents. You need to do it from the other side. Label highest leave n and remove it.

  • »
    »
    7 years ago, # ^ |
    Rev. 9   Vote: I like it 0 Vote: I do not like it

    Try this:- 10 2

    3 1 4 1 The problem here is the algorithm tries to allocate the best position for value 1,2,... and so on.But this greedy algorithm forces you to place a bigger number at the more significant position.

  • »
    »
    7 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    counter example

    4 -> 1

    2 -> 3

  • »
    »
    4 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    "Lexicographically", which means u don't want label 1 to match the smallest index, but let the smallest index to match the smallest label.

    • »
      »
      »
      4 years ago, # ^ |
        Vote: I like it 0 Vote: I do not like it

      i tried to use KAHN algorithm but use set instead of queue...this doesnt work — why?

»
7 years ago, # |
  Vote: I like it 0 Vote: I do not like it

For problem A, why the accepted output of input '100' is '100', shouldn't it be '10'? (Because first we meet 1 and then terminate of first digit with 0 and then we meet 0, thus the output is 10) sorry for my bad english

  • »
    »
    7 years ago, # ^ |
    Rev. 2   Vote: I like it 0 Vote: I do not like it

    The problem said that 0 character separates blocks consists only character 1, and the length/size of each block is the digit it represents.

    For the input 100, we can rewrite it like this: (1)0()0(). So there are 3 blocks. First block has size 1 and the other 2 have size 0. So the output is 100.

    • »
      »
      »
      7 years ago, # ^ |
        Vote: I like it +5 Vote: I do not like it

      I'm too have written solution with using split as you have, but in Java blocks with zero-length lines skips.

      • »
        »
        »
        »
        7 years ago, # ^ |
          Vote: I like it +2 Vote: I do not like it

        yes, it is like the difference between .split() and split(' ') in python

  • »
    »
    7 years ago, # ^ |
      Vote: I like it +1 Vote: I do not like it

    We divide line using '0',start,end. Then print count of '1' in every segment.

»
7 years ago, # |
  Vote: I like it 0 Vote: I do not like it

In problem F, why the answer for the string kbyjorwqjk is 11 and not 12 (test case 4)?

  • »
    »
    7 years ago, # ^ |
      Vote: I like it +10 Vote: I do not like it

    answer can't be greater than |s| + 1

    • »
      »
      »
      7 years ago, # ^ |
        Vote: I like it 0 Vote: I do not like it

      Why not? What would be the compressed version for this string?

      • »
        »
        »
        »
        7 years ago, # ^ |
          Vote: I like it +5 Vote: I do not like it

        1kbyjorwqjk

        • »
          »
          »
          »
          »
          7 years ago, # ^ |
            Vote: I like it 0 Vote: I do not like it

          Lol, my bad. For some reason I thought the quantity of characters of the period should precede it, not the number of times it is repeated. Thanks a lot for the help.

»
7 years ago, # |
  Vote: I like it +3 Vote: I do not like it

WA in test 14 prob D but i can't check what that test is

»
7 years ago, # |
  Vote: I like it 0 Vote: I do not like it

In problem D, If i make a count map for all characters for string t and then consider window length of strlen(t) in string s.

Now in each window, there is map count for all characters and then a variable storing count of number of empty characters -> '?'. Now we match the count array of t with count array of window and see if there is a match considering empty characters with all unmatched characters.

Lastly, if i get a match , I jump from i->i+strlen(t) otherewise i->i+1.

Will this algorithm work..??

  • »
    »
    7 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    It should work. Here's my solution, though I think it's slightly different from yours. I stored all positions of '?,' then iterated through them. For each position keep going through all letters in t while subtracting it from a count map if it is already in string s (not a '?'). If a letter isn't in s, we set the current '?' to that letter and repeat for all other positions. Ignore the variables 'bad' and 'mx.' I forgot to delete them but they are unused. 28608658

»
7 years ago, # |
  Vote: I like it +11 Vote: I do not like it

in problem E :

I have not understood why doing the same as the editorial but from the other side is wrong yet, I mean why labeling from 1 to N starting from the nodes with in-degree equals to zero is wrong.

I applied the proof in the editorial on that and I didn't find anything wrong, could anyone please tell where is my mistake ?

thanks in advance.

  • »
    »
    7 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    I thin there is a bug in your code, when you are trying to do something with unconnected nodes. In the test you fail judge is waiting for 13, while where is no information given about 13. And you print 15, you should print 13, becouse it is unconnected and can be smaller than 15.

    • »
      »
      »
      7 years ago, # ^ |
        Vote: I like it 0 Vote: I do not like it

      sorry if it seemed like I was defending my solution , I know it's wrong !!

      maybe the code has some bugs. However, you can see that this approach is wrong here by the counter examples that were mentioned in the above comments.

      what I want to know is why the proof in the editorial can not be applied on my approach, where does it fails!!!!!!

      • »
        »
        »
        »
        7 years ago, # ^ |
          Vote: I like it 0 Vote: I do not like it

        It works, you just fail to implement it

        • »
          »
          »
          »
          »
          7 years ago, # ^ |
            Vote: I like it 0 Vote: I do not like it

          take this counter testcase:

          4 2

          3 1

          2 4

          if you apply our approach on this test you will choose 2 first, then 3,then 1,finally 4. which will give you this permutation :

          3 1 2 4

          but the correct solution is to choose 3 first, then 1, then 2, finally 4. which will give you the correct permutation:

          2 3 1 4

          if I made a mistake, hope you clarify where it is

          • »
            »
            »
            »
            »
            »
            7 years ago, # ^ |
              Vote: I like it 0 Vote: I do not like it

            4->2->4 is a cycle

            • »
              »
              »
              »
              »
              »
              »
              7 years ago, # ^ |
                Vote: I like it 0 Vote: I do not like it

              i'm crashing my head with walls now

              4 is the number of nodes

              2 is the num of edges

              • »
                »
                »
                »
                »
                »
                »
                »
                7 years ago, # ^ |
                  Vote: I like it 0 Vote: I do not like it

                Ohhh, now i see why it doesn't work... Also look at sneaky test 6...

  • »
    »
    7 years ago, # ^ |
    Rev. 2   Vote: I like it +1 Vote: I do not like it

    From the set of nodes of in-degree equals to zero: picking node V, the one with smallest index to be labeled '1' will not always give the lexicographically smallest permutation.

    Let's apply the same approach of the editorial: let node V be labeled X (X > 1), this labeling may result that other node U (U < V) get labeled Y (Y < X) which result in lexicographically smaller permutation.

    So applying the same approach won't result in a contradiction.

  • »
    »
    5 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    I'll try to explain the reason as to why it doesn't work in the reverse direction.

    In the editorial's solution, the label of one vertex increases (X -> N), whereas the labels of some vertices decrease. In this, there is always some vertex having a lesser index whose label is decreased. So, the new labeling is lexicographically smaller than the previous one.

    While applying the same thing in the reverse direction, the label of one of the vertices decreases (X -> 1), whereas the labels of some vertices increase. Here, it might be possible that some vertex for which the label is getting increased might have a smaller index than the current vertex. So, in this case, we might end up having a lexicographically larger labeling.

    So, the proof for the reverse case can not be established using a similar reasoning.

»
7 years ago, # |
  Vote: I like it 0 Vote: I do not like it

Sorry for the incorrect formula in F, it is fixed now.

»
7 years ago, # |
  Vote: I like it 0 Vote: I do not like it

Can someone explain reason for MLE in my code?

Code : 28646208

  • »
    »
    7 years ago, # ^ |
      Vote: I like it +1 Vote: I do not like it

    Same problem as here. Your binary search may find incorrectly a big number as answer. So this vector that you create to build the answer will exceed the memory limit.

»
7 years ago, # |
  Vote: I like it +1 Vote: I do not like it

Can someone help me with my solution for D ? I'm getting WA

Code : 28647476

  • »
    »
    7 years ago, # ^ |
      Vote: I like it +2 Vote: I do not like it

    The problem was overflow inside your check function. If the frequency of some letter is big and you test a big number at the binary search the result of multiplication may exceed by far the int limit.

»
7 years ago, # |
  Vote: I like it 0 Vote: I do not like it

Could someone please explain problem D more clearly?I didn't get that.Thanks ins advance :)

  • »
    »
    7 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    I tried explaining my solution in a comment above (under Todi_Kunal). If you have any further questions, feel free to ask. 28608658

»
7 years ago, # |
  Vote: I like it 0 Vote: I do not like it

Can anyone tell me What is qsum in 825D?

  • »
    »
    7 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    How many question marks there is at string s.

  • »
    »
    7 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    Whoops, my bad. Fixed it, now it's qcnt in both initialization and formula.

»
7 years ago, # |
  Vote: I like it 0 Vote: I do not like it

In 825F how the prefix sum is calculated? How the complexity is reduced from s^3 to s^2?

»
7 years ago, # |
Rev. 2   Vote: I like it 0 Vote: I do not like it

Can someone please help me find the mistake in my code for 825F?? Getting wrong answer on test case 13. submission/28674792

»
7 years ago, # |
  Vote: I like it 0 Vote: I do not like it

Hi :) I have read that problem E can be solved with a "somewhat standard approach, involving advanced data structures and quite tedious to implement" (Petr words xD).

I understand that the intended and best solution is the one described here, but I would like to know what is this other solution? :)

Could anyone elaborate on this? Thanks

  • »
    »
    7 years ago, # ^ |
    Rev. 2   Vote: I like it 0 Vote: I do not like it

    I have a basic idea however not sure how to optimize it.

    1. Reverse the edges first.
    2. Choose the smallest index that is yet to get a number, mark all the nodes reachable from it. We can assign a number to this index only after assigning number to all the nodes reachable from it.
    3. Among the nodes reachable from this index, choose the smallest index that is yet to get a number and repeat the process.
    • »
      »
      »
      7 years ago, # ^ |
      Rev. 2   Vote: I like it 0 Vote: I do not like it

      Yes, that's the question haha, is it possible to optimize those kinds of naive algorithms?

      Another similar way will be:

      Reverse the edges.

      Go over the nodes in increasing order. For a node v, count x = the number of nodes reachable from it (including itself), v's label has to be  ≥ x, so we can choose the smallest free label among those  ≥ x and assign it to v.

      No idea if this can be done better than in O(N2)

      upd: this doesn't work as pointed by MrDindows, thanks

      The obvious bottle neck for these algorithms is to get the size of the "reach" of a node, I wonder if there's a way to optimize that, or if the other solution uses a different approach.

      • »
        »
        »
        »
        7 years ago, # ^ |
          Vote: I like it 0 Vote: I do not like it

        oh okay! misunderstood your question!

      • »
        »
        »
        »
        7 years ago, # ^ |
          Vote: I like it 0 Vote: I do not like it

        Such solution wouldn't work at all.

        Testcase:
        3 1
        3 1

        • »
          »
          »
          »
          »
          7 years ago, # ^ |
            Vote: I like it 0 Vote: I do not like it

          you're right, thanks. But do you know what "standard approach" is Petr talking about in that post?

»
7 years ago, # |
Rev. 2   Vote: I like it 0 Vote: I do not like it

Can anyone explain test case in G?

What i understand that graph is 1-2-3-4 and queries are:

1)set 2 vertex black

2)set 2 vertex black (again?)

3)get answer for vertex x=2.
we have only one black vertex (=2), so the only path between 2 and black vertex is zero path from 2 to 2. so the answer is 2. Where am i wrong?

»
7 years ago, # |
  Vote: I like it 0 Vote: I do not like it

For problem C, why not choose the most hard problem like with difficulty 10^9 to solve at first? Then we can solve all other problems , isn't this the best way?

  • »
    »
    7 years ago, # ^ |
      Vote: I like it +7 Vote: I do not like it

    Before solving a problem with difficulty Y on any judge,you have to solve a problem with difficulty which is greater than or equal to Y/2

»
7 years ago, # |
  Vote: I like it 0 Vote: I do not like it

can anyone please explain what is wrong with my solution of F http://codeforces.com/contest/825/submission/28946671

»
7 years ago, # |
  Vote: I like it 0 Vote: I do not like it

Can someone please help me debug this code ?.I have checked it many times and it seems correct to me.

»
4 years ago, # |
  Vote: I like it 0 Vote: I do not like it

In problem D what is wrong in my code, I almost check every test case except truncated ones but I am unable to find a bug please help https://codeforces.com/contest/825/submission/80789724